#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include <dmusicc.h>
#include <dmusici.h>
#include "resource.h"

#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"dxguid.lib")

#define MYWNDTITLE	"DX8_Music_Inst"
#define RELEASE(p)	if (p){p->Release();p=NULL;}
#define INST_MAX	1	// eȂŉty̍ő吔

IDirectMusicPerformance8			*g_pDMP  = NULL;
IDirectMusicPort8					*g_pDMPT = NULL;
IDirectMusicDownloadedInstrument8	*g_pDMDI = NULL;
IDirectMusicLoader8					*g_pDML = NULL;
IDirectMusicCollection8				*g_pDMC = NULL;

BYTE g_velocity = 64;	// xVeBi0`127j
BYTE g_value = 64;		// MIDIli0`127j

bool Init_DM(HWND hDlg);
HRESULT Enum_Inst(HWND hDlg);
HRESULT Play_Inst(DWORD dwPatch,BYTE bVelocity, BYTE bMidiValue);
HRESULT Play_Inst2(BYTE bVelocity, BYTE bMidiValue);
void Term_DM();

int CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		InitCommonControls();
		if(!Init_DM(hDlg)){ 	// DirectMusic
			MessageBox(hDlg,"DirectMusic8̏Ɏs܂B","DMusic8",MB_OK | MB_ICONSTOP);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		{
		SendDlgItemMessage(hDlg,IDC_SPIN1,UDM_SETRANGE,0,MAKELONG(127, 0));
		SendDlgItemMessage(hDlg,IDC_SPIN2,UDM_SETRANGE,0,MAKELONG(127, 0));
		HWND hEdit1 = GetDlgItem(hDlg,IDC_EDIT1);
		HWND hEdit2 = GetDlgItem(hDlg,IDC_EDIT2);
		SendDlgItemMessage(hDlg,IDC_SPIN1,UDM_SETBUDDY,(WPARAM) hEdit1, 0);
		SendDlgItemMessage(hDlg,IDC_SPIN2,UDM_SETBUDDY,(WPARAM) hEdit2, 0);
		SendDlgItemMessage(hDlg,IDC_SPIN1,UDM_SETPOS,0,MAKELONG(g_velocity, 0));
		SendDlgItemMessage(hDlg,IDC_SPIN2,UDM_SETPOS,0,MAKELONG(g_value, 0));
		}
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDC_COMBO1:	// F
			if(HIWORD(wParam) == CBN_SELCHANGE){
				DWORD index = SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0);
				DWORD dwPatch = SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETITEMDATA,index,0);
				Play_Inst(dwPatch,g_velocity,g_value);
			}
			break;
		case IDC_EDIT1:		// m[g̃xVeB
			if(HIWORD(wParam) == EN_CHANGE){
				g_velocity = (BYTE) GetDlgItemInt(hDlg,IDC_EDIT1,NULL,FALSE);
				Play_Inst2(g_velocity,g_value);
			}
			break;
		case IDC_EDIT2:		// m[g̒l
			if(HIWORD(wParam) == EN_CHANGE){
				g_value = (BYTE) GetDlgItemInt(hDlg,IDC_EDIT2,NULL,FALSE);
				Play_Inst2(g_velocity,g_value);
			}
			break;
		case IDC_BUTTON1:	// Đ
			if(HIWORD(wParam) == BN_CLICKED){
				Play_Inst2(g_velocity,g_value);
			}
			break;
		case IDOK:			// I
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;

		default:
			return FALSE;
		}
		break;

	case WM_CLOSE:
		DestroyWindow(hDlg);
		Term_DM();			// DirectMusic̏I
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

int APIENTRY WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;
	HWND hDlg;
	
	hDlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG1),NULL,DlgProc);
	ShowWindow(hDlg, nCmdShow);
	
	while(GetMessage(&msg,NULL,0,0)) {
		if (IsDialogMessage(hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// DirectMusic ̏
bool Init_DM(HWND hDlg)
{
	CoInitialize(NULL);
	if(FAILED(CoCreateInstance(CLSID_DirectMusicPerformance,NULL,CLSCTX_INPROC,IID_IDirectMusicPerformance8,(void **)&g_pDMP))){
		MessageBox(NULL,"DirectMusicPerformance8̍쐬Ɏs܂B","DMusic8",MB_OK | MB_ICONSTOP);
		return 0;
	}
	if(FAILED(g_pDMP->InitAudio(NULL,NULL,NULL,DMUS_APATH_SHARED_STEREOPLUSREVERB,INST_MAX,DMUS_AUDIOF_ALL,NULL)))
	{
		MessageBox(NULL,"ptH[}X̏Ɏs܂B","DMusic8",MB_OK | MB_ICONSTOP);
		return 0;
	}
	if(FAILED(g_pDMP->PChannelInfo(0, &g_pDMPT, NULL, NULL)))
	{
		MessageBox(NULL,"DirectMusicPort8̎擾Ɏs܂B","DMusic8",MB_OK | MB_ICONSTOP);
		return 0;
	}
	if(FAILED(CoCreateInstance(CLSID_DirectMusicLoader,NULL,CLSCTX_INPROC,IID_IDirectMusicLoader8,(void **)&g_pDML))){
		MessageBox(NULL,"DirectMusicLoader8̍쐬Ɏs܂B","DMusic8",MB_OK | MB_ICONSTOP);
		return 0;
	}
	//RNV̉F
	Enum_Inst(hDlg);
	return 1;
}// Init_DM

// RNVׂ̂ẲF
HRESULT Enum_Inst(HWND hDlg)
{
	HRESULT hr = S_OK;
	
	if(g_pDML){
		//ftHgF̐ݒ
		DMUS_OBJECTDESC desc; 
		ZeroMemory(&desc, sizeof(desc));
		desc.dwSize 		= sizeof(DMUS_OBJECTDESC);
		desc.guidClass		= CLSID_DirectMusicCollection;
		desc.guidObject 	= GUID_DefaultGMCollection;
		desc.dwValidData	= (DMUS_OBJ_CLASS | DMUS_OBJ_OBJECT);
		
		g_pDML->GetObject(&desc, IID_IDirectMusicCollection8,(void **)&g_pDMC);
		if(g_pDMC){
			int 	i;
			DWORD	dwPatch;
			char	s[MAX_PATH],szName[MAX_PATH];
			WCHAR	wszName[MAX_PATH];
			
			for(i=0;hr==S_OK;i++){
				hr = g_pDMC->EnumInstrument(i,&dwPatch,wszName,MAX_PATH);
				if(SUCCEEDED(hr)){
					WideCharToMultiByte(CP_ACP,0,wszName,sizeof(wszName),szName,sizeof(szName),NULL,NULL);
					_snprintf(s,sizeof(s),"%03d  %s",i,szName);
					SendDlgItemMessage(hDlg,IDC_COMBO1,CB_INSERTSTRING,i,(LPARAM)s);
					SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETITEMDATA,i,(LPARAM)dwPatch);
				}
			}
		}
	}
	return hr;
}// Enum_Inst

// F̉t
// dwPatch   : [IN] F̃pb`ԍ
// bVelocity : [IN] m[g̃xVeB
// bMidiValue: [IN] m[g̒l
HRESULT Play_Inst(DWORD dwPatch, BYTE bVelocity, BYTE bMidiValue)
{
	HRESULT hr = E_FAIL;
	
	// F|[gɃ_E[h
	IDirectMusicInstrument8 *pDMI = NULL;
	hr = g_pDMC->GetInstrument(dwPatch,&pDMI);
	if(SUCCEEDED(hr)){
		g_pDMPT->DownloadInstrument(pDMI,&g_pDMDI,NULL,0);
		g_pDMPT->Compact();
	}
	RELEASE(pDMI);
	// bZ[WɃX^vƂł悤AptH[}X c[Ot擾B
	IDirectMusicGraph* pDMG = NULL;
	hr = g_pDMP->QueryInterface(IID_IDirectMusicGraph, (void **)&pDMG);
	if(FAILED(hr)){
		MessageBox(NULL,"DirectMusicGraph̍쐬Ɏs܂B","DMusic8",MB_OK | MB_ICONSTOP);
		return hr;
	}
	// `l 0 ɉFݒ肷
	DMUS_PATCH_PMSG *pDMUS_PATCH_PMSG = NULL;
	if(SUCCEEDED(hr)){
		hr = g_pDMP->AllocPMsg( sizeof(DMUS_PATCH_PMSG), (DMUS_PMSG **)&pDMUS_PATCH_PMSG);
	}
	if(SUCCEEDED(hr)){
		pDMUS_PATCH_PMSG->dwType = DMUS_PMSGT_PATCH;
		pDMUS_PATCH_PMSG->dwPChannel = 0;
		pDMUS_PATCH_PMSG->dwFlags = DMUS_PMSGF_REFTIME;
		pDMUS_PATCH_PMSG->byInstrument = (BYTE)(dwPatch & 0x7F);
		pDMUS_PATCH_PMSG->byLSB = (BYTE)((dwPatch & 0x7f00) >> 8);
		pDMUS_PATCH_PMSG->byMSB = (BYTE)((dwPatch & 0x7f0000) >> 16);
		hr = pDMG->StampPMsg((DMUS_PMSG *)pDMUS_PATCH_PMSG);
	}
	if(SUCCEEDED(hr)){
		hr = g_pDMP->SendPMsg((DMUS_PMSG *)pDMUS_PATCH_PMSG);
		if(FAILED(hr)){
			g_pDMP->FreePMsg((DMUS_PMSG *)pDMUS_PATCH_PMSG);
		}
	}
	else{
		return hr;
	}
	// tp[^ݒ肵ĉFt
	Play_Inst2(bVelocity, bMidiValue);
	hr = pDMG->StampPMsg((DMUS_PMSG *)pDMUS_PATCH_PMSG);
	RELEASE(pDMG);
	return hr;
}// Play_Inst

// F̉tiF̃_E[hȂj
// bVelocity : [IN] m[g̃xVeB
// bMidiValue: [IN] m[g̒l
HRESULT Play_Inst2(BYTE bVelocity, BYTE bMidiValue)
{
	HRESULT hr = E_FAIL;
	
	// tp[^ݒ肵ĉFt
	DMUS_NOTE_PMSG *pDMUS_NOTE_PMSG = NULL;
	hr = g_pDMP->AllocPMsg( sizeof(DMUS_NOTE_PMSG), (DMUS_PMSG **)&pDMUS_NOTE_PMSG);
	if(SUCCEEDED(hr)){
		pDMUS_NOTE_PMSG->dwType = DMUS_PMSGT_NOTE;
		pDMUS_NOTE_PMSG->dwPChannel = 0;
		pDMUS_NOTE_PMSG->dwFlags = DMUS_PMSGF_REFTIME;
		pDMUS_NOTE_PMSG->bFlags = DMUS_NOTEF_NOTEON;
		pDMUS_NOTE_PMSG->bVelocity = bVelocity;
		pDMUS_NOTE_PMSG->bMidiValue = bMidiValue;
		pDMUS_NOTE_PMSG->mtDuration = DMUS_PPQ * 4; // m[gŚi4  ~ 4j
		hr = g_pDMP->SendPMsg((DMUS_PMSG *)pDMUS_NOTE_PMSG);
		if(FAILED(hr)){
			g_pDMP->FreePMsg((DMUS_PMSG *)pDMUS_NOTE_PMSG);
		}
	}
	return hr;
}// Play_Inst2

// DirectMusic ̏I
void Term_DM()
{
	if(g_pDMPT && g_pDMDI){
		g_pDMPT->UnloadInstrument(g_pDMDI);
	}
	if(g_pDMP){
		g_pDMP->CloseDown();
	}
	RELEASE(g_pDMC);
	RELEASE(g_pDML);
	RELEASE(g_pDMDI);
	RELEASE(g_pDMPT);
	RELEASE(g_pDMP);
}// Term_DM
